<?

##
## implib.php3
##
## IMP v1.0
## Copywrite 1998 Charles J. Hagenbuch <chuck@osmos.ml.org>
##
## This code is under the GNU Public License
## See the file COPYING in this directory
##


// algorithm contributed by Richard Lynch: <lynch@lscorp.com>

function fill_paragraphs($text, $wrap=80, $break="\n") {
  // break the text into paragraphs by stripping off any newline characters
  $paragraphs = split("\n", "$text");
  
  // format one paragraph at a time
  for ($i = 0; $i < sizeof($paragraphs); $i++) {
    $paragraphs[$i] = textwrap($paragraphs[$i], $wrap, $break);
  }
  // concatenate the formatted paragraphs into a single string
  // with a newline character between each element
  return implode($break, $paragraphs);
}


// Contributed by Richard Lynch: <lynch@lscorp.com>

function textwrap($text, $wrap=80, $break="\n") {
  $len = strlen($text);
  if ($len > $wrap) {
    $result = '';         // massaged text
    $lastWhite = 0;  // position of last whitespace char
    $lastChar = 0;   // position of last char
    $lastBreak = 0;  // position of last break
    
    // while there is text to process
    while ($lastChar < $len) {
      $char = substr($text, $lastChar, 1);  // get the next character
      
      // if we are beyond the wrap boundary and there is a place to break
      if (($lastChar - $lastBreak > $wrap) && ($lastWhite > $lastBreak)) {
        $result .= substr($text, $lastBreak, ($lastWhite - $lastBreak)) . $break;
	$lastChar = $lastWhite + 1;
	$lastBreak = $lastChar;
      }
      
      // might include other characters as valid whitespace...
      if ($char == ' ' || $char == chr(13) || $char == chr(10)) {
        $lastWhite = $lastChar;            // note the position of the last white space
      }
      $lastChar = $lastChar + 1;           // advance the last character position by one
    }
    $result .= substr($text, $lastBreak);  // build line
  }
  else {
    $result = $text;  // if everything can fit on the line
  }
  return $result;
}


function gm_offset() {
  $offset = ((date(H) - gmdate(H)));
  if ($offset >= 0) { return sprintf("+%02d", $offset) . "00"; }
  else { return sprintf("-%02d", -$offset) . "00"; }
}

##
## End IMPlib
##

?>
